// $Id: d1mach.cc,v 1.7 1994/08/19 18:11:19 bengt Exp $ 

// double-precision machine constants
//
// d1mach(1) = b**(emin-1), the smallest positive magnitude.
// d1mach(2) = b**emax*(1 - b**(-t)), the largest magnitude.
// d1mach(3) = b**(-t), the smallest relative spacing.
// d1mach(4) = b**(1-t), the largest relative spacing.
// d1mach(5) = log10(b)

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef FORTRAN_UNDERSCORES
#define d1mach d1mach_
#endif

#ifdef FORTRAN_UPPERCASE
#define d1mach D1MACH
#endif

#include <math.h>
#include <float.h>
#include <stdlib.h>

class d1table {
public:
  double table[6];
  d1table();
};

d1table::d1table() {
  table[1] = DBL_MIN;
  table[2] = DBL_MAX;
  table[3] = DBL_EPSILON/FLT_RADIX;
  table[4] = DBL_EPSILON;
  table[5] = log10(FLT_RADIX);
}

static d1table thetable;

extern "C" double
d1mach(long int *i)
{
  if (*i < 1 || *i > 5)
    abort();
  return thetable.table[*i];
}

#ifdef MAIN
#include <iostream.h>
main()
{
  for (long int i = 1; i <= 5; i++)
    cout << "d1mach(" << i << ") = " << d1mach(&i) << "\n";
}
#endif
