/* 	-*- c++ -*-
 Copyright (C) 1992 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

// $Id: Newton.h,v 1.3 1994/08/19 18:21:46 bengt Exp $


#ifndef _Newton_h
#define _Newton_h

#ifdef __GNUG__
#pragma interface
#endif

#include "SIntegrator.h"

class NewtonIntegrator : public StochasticIntegrator {
 public:
  const char *name() const;
  const char *documentation() const;
  // Use the generic driver ContinuousIntegrator::loop()
 private:
  bool initialize_integrator();
  inline bool call_integrator();
  Vect scratch;
  Vect y1, y2;
  Vect a0, a1, b0, b1, b2, b3;
  double sqrt_3_h;
  double q_h_2;
  double q_2_3;
  double q_2_9;
  double q_20_27;
  double q_10_27;
  double q_1_40;
  double q_1_16;
  void newton(fp f,
	      unsigned int number_of_states,
	      double *t, double stepsize,
	      Vect &state_vect);
};

#endif
