/* -*- c++ -*-
 Copyright (C) 1992 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

// $Id: Rkf45.h,v 1.4 1994/08/24 09:58:06 bengt Exp $

#ifndef _Rkf45_h
#define _Rkf45_h

#ifdef __GNUG__
#pragma interface
#endif

#include "CIntegrator.h"

class Rkf45Integrator : public ContinuousIntegrator {
 public:
  const char *name() const;
  const char *documentation() const;
  bool loop(bool initialize);
  Rkf45Integrator();
 private:
  bool initialize_integrator();
  inline bool call_integrator();
  int neqn, iflag, iwork[5];
  double tout, *work; 
};

#endif
