/* -*- c++ -*-
Copyright  1993 Bengt Mrtensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

// $Id: Store.cc,v 1.2 1994/01/12 22:58:26 bengt Exp $

#ifdef __GNUG__
#pragma implementation
#endif

#include "externals.h"
#include <Store.h>

static const unsigned int allocate_chunk = 100;

unsigned int Store::discontinuity_table_size = 0;
unsigned int *Store::discontinuities = NULL;
unsigned int Store::no_of_discontinuities;
  
void
Store::add_discontinuity() {
  if (no_of_discontinuities >= discontinuity_table_size) {
    unsigned int *old = discontinuities;
    discontinuities = new unsigned int[discontinuity_table_size + allocate_chunk];
    for (unsigned int i = 0; i < discontinuity_table_size; i++)
      discontinuities[i] = old[i];
    delete old;
    discontinuity_table_size += allocate_chunk;
  }
  discontinuities[no_of_discontinuities++] = sample_no;
}

void
Store::reset_discontinuities() {
  no_of_discontinuities = 0;
}

unsigned int
Store::get_no_of_trajectories() {
  return no_of_discontinuities;
}

const unsigned int *
Store::get_discontinuities() {
  return (const unsigned int *) discontinuities;
}
