/*
 Copyright (C) 1992 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

// $Id: debug.cc,v 1.7 1994/08/19 18:38:31 bengt Exp $

// Debugging setup etc.

#include "externals.h"

extern void 
debug_setup()
{
  // Debugging the scanner
  zz_flex_debug = (gnansdebug & 1);

  // Debugging the parser
  zzdebug = (gnansdebug & 2);

  // Tracing mallocs
  malloc_debug = gnansdebug & 4;

  // Tracing workproc
  trace_workproc = gnansdebug & 8;

  // Tracing calls
  trace_calls = gnansdebug & 16;

  // Tracing widget creation etc
  trace_widgets = gnansdebug & 32;

  // Run in batch mode instead of workprocs
  workprocs = ! (gnansdebug & 64);
  
  // Tracing in (some) integration algorithms
  trace_algorithms = gnansdebug & 128;
}

// If the development flag is flipped, this function is called.
// It makes a some more flags (for debugging) available to the user,
// who is assumed to be "developer".

extern void
update_development_status()
{
  switches_table = development ?
    switches_table_development : switches_table_standard;
}
