/*
 Copyright (C) 1992 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

/* $Id: globals.cc,v 1.10 1994/08/17 18:57:46 bengt Exp $ */

/*
 * This file contains all global variables. They are described in
 * translator.h
 */

#include <config.h>
#include "translator.h"

/****************************************************************/
unsigned int number_of_states = 0;
unsigned int number_of_state_vectors = 0;
unsigned int number_of_state_matrices = 0;
unsigned int number_of_parameters = 0;
unsigned int number_of_parameter_vectors = 0;
unsigned int number_of_parameter_matrices = 0;
unsigned int number_of_functions = 0;
unsigned int number_of_variables = 0;
unsigned int number_of_times = 4;	// START, STOP, STORE, ACCEPTED
unsigned int number_of_randoms = 0;
unsigned int number_of_uniforms = 0;
unsigned int number_of_normals = 0;
unsigned int number_of_wieners = 0;

bool deps_debug = false;
bool trace_lineno = false;
bool trace_mallocs = false;
unsigned int translator_debug = 0;

unsigned int errors_occured = 0;

SystemType system_type = undefined;
std::string system_name;
std::string input_filename;
std::string output_filename;
std::string time_variable_name;
FILE *outputfile;
std::string c_declarations;

translator_par states[MAXSTATES];
translator_par state_vectors[SMALLTABLESIZE];
translator_par state_matrices[SMALLTABLESIZE];
translator_par functions[MAXSTATES];
translator_par parameters[MAXSTATES];
translator_par parameter_vectors[SMALLTABLESIZE];
translator_par parameter_matrices[SMALLTABLESIZE];
translator_par variables[MAXSTATES];
translator_par randoms[MAXSTATES];
translator_par uniforms[MAXSTATES];
translator_par normals[MAXSTATES];
translator_par wieners[MAXSTATES];
std::string times_names[SMALLTABLESIZE];
std::string times_buffer[SMALLTABLESIZE];

symrec *sym_table = NULL;
riccati_data_class riccati_data;
std::string *current_block;
deprec *current_dependencies = NULL;
unsigned int lineno = 1;
unsigned int function_calls = 0;
unsigned int cpp_calls = 0;

char *current_line = NULL;
